const jwt = require('jsonwebtoken');

const SECRET = "12345";

async function validateToken(token){
    let result = await jwt.verify(token , SECRET , (error , value)=>{
        if(value){
            return jwt.decode(token,SECRET);
        }
        else if(error){
            return error;
        }
    });
    if(result.username){
        return result;

    }
    else{
        throw result;
    }
}

async function createToken(user){
    let userRole;
    if(user.admin === true){
        userRole = "admin";
    }
    else if(user.admin === false){
        userRole = "user";
    }
    else{
        userRole = "visitor";
    }
    let userToken = await jwt.sign({id : user['id'] , username : user['username'] , email :  user['email'] , role : userRole},SECRET,{expiresIn : '1h'});
    return userToken;
}

module.exports = {
    validateToken,
    createToken,
}